// Load dts shapes and merge animations
datablock TSShapeConstructor(berserkerpredatorDts)
{
	baseShape  = "./berserkerpredator.dts";
	sequence0  = "./bpred_root.dsq root";

	sequence1  = "./bpred_run.dsq run";
	sequence2  = "./bpred_run.dsq walk";
	sequence3  = "./bpred_back.dsq back";
	sequence4  = "./bpred_side.dsq side";

	sequence5  = "./bpred_crouch.dsq crouch";
	sequence6  = "./bpred_crouchrun.dsq crouchRun";
	sequence7  = "./bpred_crouchback.dsq crouchBack";
	sequence8  = "./bpred_crouchside.dsq crouchSide";

	sequence9  = "./bpred_look.dsq look";
	sequence10 = "./bpred_headside.dsq headside";
	sequence11 = "./bpred_root.dsq headUp";

	sequence12 = "./bpred_jump.dsq jump";
	sequence13 = "./bpred_jump.dsq standjump";
	sequence14 = "./bpred_fall.dsq fall";
	sequence15 = "./bpred_root.dsq land";

	sequence16 = "./bpred_rightstab.dsq armAttack";
	sequence17 = "./bpred_armreadyleft.dsq armReadyLeft";
	sequence18 = "./bpred_armreadyright.dsq armReadyRight";
	sequence19 = "./bpred_armreadyboth.dsq armReadyBoth";
	sequence20 = "./bpred_spearready.dsq spearready";  
	sequence21 = "./bpred_spearthrow.dsq spearThrow";

	sequence22 = "./bpred_root.dsq talk";  

	sequence23 = "./bpred_death.dsq death1"; 
	
	sequence24 = "./bpred_root.dsq shiftUp";
	sequence25 = "./bpred_root.dsq shiftDown";
	sequence26 = "./bpred_root.dsq shiftAway";
	sequence27 = "./bpred_root.dsq shiftTo";
	sequence28 = "./bpred_root.dsq shiftLeft";
	sequence29 = "./bpred_root.dsq shiftRight";
	sequence30 = "./bpred_root.dsq rotCW";
	sequence31 = "./bpred_root.dsq rotCCW";

	sequence32 = "./bpred_root.dsq undo";
	sequence33 = "./bpred_root.dsq plant";

	sequence34 = "./bpred_sit.dsq sit";

	sequence35 = "./bpred_root.dsq wrench";

   sequence36 = "./bpred_actvate.dsq activate";
   sequence37 = "./bpred_activate2.dsq activate2";

   sequence38 = "./bpred_root.dsq leftrecoil";
};    

datablock AudioProfile(berserkerpredatorDeathSound)
{
	fileName = "./predatordeath.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(berserkerpredatorPainSound)
{
    fileName = "./predatorpain.wav";
    description = AudioClose3d;
    preload = true;
};
datablock AudioProfile(berserkerpredatorJumpSound)
{
    fileName = "./predatorjump.wav";
    description = AudioClose3d;
    preload = true;
};

datablock DebrisData( berserkerpredatorDebris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = false;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};             

datablock PlayerData(berserkerpredatorArmor)
{
     renderFirstPerson = false;
   emap = false;
   
   className = Armor;
   shapeFile = "./berserkerpredator.dts";
   cameraMaxDist = 7;
   cameraTilt = 0;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 0;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 60;
   drag = 0.1;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 170;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 28 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 6;
   maxBackwardSpeed = 4;
   maxSideSpeed = 6;

   maxForwardCrouchSpeed = 17;
   maxBackwardCrouchSpeed = 6;
   maxSideCrouchSpeed = 6;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 1;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 15 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("1.5 1.2 2.7", 4); //"2.5 2.5 2.4";
   crouchBoundingBox	= vectorScale("1.5 1.4 2", 4); //"2.5 2.5 2.4";
   proneBoundingBox		= vectorScale("2.5 2.5 2.4", 4); //"2.5 2.5 2.4";


   useCustomPainEffects = true;
   PainSound			= berserkerpredatorPainSound;
   DeathSound			= berserkerpredatorDeathSound;

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 65;
   jumpSurfaceAngle = 66;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= berserkerpredatorJumpSound;

   // Footstep Sounds
//   FootSoftSound        = HorseFootFallSound;
//   FootHardSound        = HorseFootFallSound;
//   FootMetalSound       = HorseFootFallSound;
//   FootSnowSound        = HorseFootFallSound;
//   FootShallowSound     = HorseFootFallSound;
//   FootWadingSound      = HorseFootFallSound;
//   FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "Berserker Predator";
	rideable = false;
		lookUpLimit = 0.6;
		lookDownLimit = 0.2;

   numMountPoints = 1;
   mountThread[0] = "sit";
   mountNode[0] = 0;

	canRide = false;
	showEnergyBar = false;
	paintable = false;

	brickImage = berserkerpredatorBrickImage;	//the imageData to use for brick deployment

};

function berserkerpredatorStartCloak(%obj)
{
if(!isObject(%obj) || %obj.berserkerpredatorCloaking || %obj.berserkerpredatorCloaked || (%obj.currTool >= 0 && %obj.currTool !$= ""))
return -1;
%obj.berserkerpredatorCloaking = 1;
%obj.berserkerpredatorCloaked = 1;
for(%a = 1; %a < 100; %a++)
{
%c = mAsin(%a * 0.01 * $pi/4);
%obj.schedule(%a * 5,setNodeColor,"ALL", 0.5 * %c SPC 0.75 * %c SPC %c SPC "1.0");
}
%obj.schedule(500,hideNode,"ALL");
schedule(500,0,berserkerpredatorStopCloak,%obj);
}
function berserkerpredatorStartDeCloak(%obj)
{
if(!isObject(%obj) || %obj.berserkerpredatorCloaking || !%obj.berserkerpredatorCloaked)
return -1;
%obj.berserkerpredatorCloaking = 1;
%obj.berserkerpredatorCloaked = 0;
%obj.unHideNode("ALL");
%obj.client.applyBodyParts();
for(%a = 1; %a < 100; %a++)
{
%c = 1 - mAsin(%a * 0.01 * $pi/4);
%obj.schedule(%a * 5,setNodeColor,"ALL", %c SPC %c SPC %c SPC "1.0");
}
%obj.client.schedule(500,applyBodyColors);
schedule(500,0,berserkerpredatorStopCloak,%obj);
}
function berserkerpredatorStopCloak(%obj)
{
if(!isObject(%obj))
return -1;
%obj.berserkerpredatorCloaking = "";
}

package PredatorCloak
{
function serverCmdLight(%client)
{
%player = %client.player;
if(isObject(%player))
{
if(%player.getDatablock() == berserkerpredatorArmor.getID())
if(%player.berserkerpredatorCloaked)
berserkerpredatorStartDeCloak(%player);
else
berserkerpredatorStartCloak(%player);
}
else
parent::serverCmdLight(%client);
}
function serverCmdUseTool(%client,%slot)
{
%player = %client.player;
if(isObject(%player))
if(%player.berserkerpredatorCloaked)
berserkerpredatorStartDeCloak(%player);
parent::serverCmdUseTool(%client,%slot);
}
};
activatePackage(PredatorCloak);
